---
title: FileSystemDirectoryEntry.removeRecursively()
slug: Web/API/FileSystemDirectoryEntry/removeRecursively
tags:
  - API
  - File System API
  - File and Directory Entries API
  - FileSystemDirectoryEntry
  - Files
  - Method
  - Non-standard
  - Obsolete
  - Reference
  - removeRecursively
---
<p>{{APIRef("File System API")}}{{Obsolete_header}}{{SeeCompatTable}}</p>

<p>The {{domxref("FileSystemDirectoryEntry")}} interface's method <code><strong>removeRecursively</strong></code><strong><code>()</code></strong> removes the directory as well as all of its content, hierarchically iterating over its entire subtree of descendant files and directories.</p>

<p>To remove a single file, or an empty directory, you can also use {{domxref("FileSystemEntry.remove()")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>FileSystemDirectoryEntry</em>.removeRecursively(<em>successCallback</em>[, <em>errorCallback</em>]);</pre>

<h3 class="syntaxbox" id="Parameters">Parameters</h3>

<dl>
 <dt><code>successCallback</code></dt>
 <dd>A function to call once the directory removal process has completed. The callback has no parameters.</dd>
 <dt><code>errorCallback</code> {{optional_inline}}</dt>
 <dd>A function to be called if an error occurs while attempting to remove the directory subtree. Receives a {{domxref("FileError")}} describing the error which occurred as input.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>{{jsxref("undefined")}}.</p>

<h3 id="Errors">Errors</h3>

<p>If an error occurs and an <code>errorCallback</code> was specified, it gets called with a single parameter: a {{domxref("FileError")}} object describing the error. The {{domxref("FileError.code")}} specifies what type of error occurred, as follows:</p>

<dl>
 <dt><code>FileError.INVALID_MODIFICATION_ERR</code></dt>
 <dd>An attempt was made to remove the root directory; this is not permitted.</dd>
 <dt><code>FileError.NO_MODIFICATION_ALLOWED_ERR</code></dt>
 <dd>The file system's state doesn't permit modification.</dd>
 <dt><code>FileError.NOT_FOUND_ERR</code></dt>
 <dd>The directory represented by the {{domxref("FileSystemDirectoryEntry")}} no longer exists.</dd>
 <dt><code>FileError.NOT_READABLE_ERR</code></dt>
 <dd>The directory is not accessible; perhaps it's in use by another application or is locked at the operating system level.</dd>
 <dt><code>FileError.SECURITY_ERR</code></dt>
 <dd>The directory could not be removed for security reasons. Possible reasons include:
 <ul>
  <li>The directory and/or its contents may not be safe to access from a Web application.</li>
  <li>Too many file system calls are being made.</li>
  <li>Other security concerns as raised by the user agent or the operating system.</li>
 </ul>
 </dd>
</dl>

<div class="note">
<p>If you try to delete a directory which contains one or more files that can't be removed, or if an error occurs while deletion of a number of files is underway, some files may not be deleted. You should provide an <code>errorCallback</code> to watch for and handle this, perhaps by trying again.</p>
</div>

<h2 id="Example">Example</h2>

<pre class="brush: js">directory.removeRecursively(function() {
  /* The directory was removed successfully */
}, function() {
  /* an error occurred while removing the directory */
});</pre>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileSystemDirectoryEntry.removeRecursively")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API">File and Directory Entries API</a></li>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API/Introduction">Introduction to the File System API</a></li>
 <li>{{domxref("FileSystemDirectoryEntry")}}</li>
 <li>{{domxref("FileSystemEntry.remove()")}}</li>
</ul>
